<?php

class konkurs {
	
    public $info;    
    public $boolean_fields = array(
        'approve_apps', 
        'email_validation', 
        'use_captcha', 
        'email_alerts',
		'link_to_konkurs',
		'wave',
    );
    public $config = array();
    
	public function __construct($id=0, $status="") {
		global $wpdb;		
        
        if($id == 0) {
            $query = 'SELECT * FROM '. $wpdb -> konk_contests .' WHERE status = "running" AND active = 1 ORDER BY date_created DESC LIMIT 1';
            
            $results = $wpdb -> get_results($query, 'ARRAY_A');        
			if(is_array($results)) {   
				$this -> info = $results[0];
                $this -> type = $this -> info['type'];
			} else {
				return false;
			}
            
        } elseif($id > 0) {
            $query = 'SELECT * FROM '. $wpdb -> konk_contests .' WHERE id = '.$id.' ';            
            $results = $wpdb -> get_results($query, 'ARRAY_A');        			
			$this -> info = $results[0];
            $this -> type = $this -> info['type'];
        } elseif($id == -1) {
            //we-re adding a new contest and sending the TYPE as parameter, rather than the STATUS
            $this -> type = $status;
        }
		if(isset($this -> type)) {
            $this -> config = konk_get_module(KONK_MODULES_PATH.'/'.$this -> type);
            require_once(KONK_MODULES_PATH.'/'.$this -> type.'/module.php');        
        }
        
		if(isset($this -> info['start_date'])) {
			//contest loaded, therefore it exists
			$now = time();			
			$this -> start_timestamp = konk_get_timestamp($this -> info['start_date']);
			$this -> end_timestamp = konk_get_timestamp($this -> info['end_date']);
			
			if($this -> start_timestamp <= $now && $this -> end_timestamp > $now && $this -> info['status'] != 'running')
				$this -> set_status('running');
				
			if($this -> start_timestamp > $now && $this -> info['status'] != 'pending') {
				$this -> set_status('pending');
			}
		
			if($this -> end_timestamp <= $now && $this -> info['status'] != 'stopped') {
				$this -> set_status('stopped');
			} 
			
			if($this -> end_timestamp > $now && $this -> status == 'stopped') {
				if($this -> start_timestamp >= $now)
					$this -> set_status('pending');
				else
					$this -> set_status('running');
			}
		}
		
		if(strlen($status) && $this -> info['status'] != $status)
			return false;
		//if id == -1 then we are creating a new contest
	}	
	
	public function set_status($new_status) {
		global $wpdb;
		
		$query = 'UPDATE '. $wpdb -> konk_contests .' SET status = "'.$new_status.'" WHERE id = '. $this -> info['id'] .' ';
		$wpdb -> query($query);
		
		//alert owner - contest are also deactivated by user action - if user enters a contest page and the contest has to be deactivated 
		$this -> alert(sprintf(__('Statusul concursului a fost schimbat in %s', 'wp-konkurs'), $new_status));
	}
	
	public function get_form($form, $data) {
		
		$readable = true;
		$template = '';
		$module_dir = KONK_MODULES_PATH.'/'.$this -> type;		
		if(!file_exists($module_dir) || !is_readable($module_dir)) {
			$template .= sprintf(KONK_DIR_ERROR, $module_dir, 644);
			$readable = false;
		} else {
			$h = opendir($module_dir);
			if($h) {
				$count = 0;
				while(false !== ($file = readdir($h))) {					
					if(is_file($module_dir.'/'.$file)) {
						if(!is_readable($module_dir.'/'.$file)) {
							$template .= sprintf(KONK_FILE_ERROR, $module_dir.'/'.$file, 644);
							$readable = false;
						}
					}
				}
			} else {
				$template .= sprintf(KONK_FILE_ERROR, $module_dir.'/'.$file, 644);
				$readable = false;
			}
		}
		
		$main_form_file = KONK_PLUGIN_PATH.'/main_contest_form.html';	
		
		if(!file_exists($main_form_file) || !is_readable($main_form_file)) {
			$template .= sprintf(KONK_FILE_ERROR, $main_form_file, 644);
			$readable = false;
		}
		
		$module_form_file = $module_dir.'/'.$form.'.html';
		if($readable) {		
			$module_template = implode('', file($module_form_file));
	        $main_template = implode('', file($main_form_file));
	        $template = str_replace('##module_contest_form##', $module_template, $main_template);
			
			$host_prefix = strpos($_SERVER['HTTP_HOST'], 'http://') === false  ? 'http://' : '';
			$_SERVER['HTTP_HOST'] = $host_prefix.$_SERVER['HTTP_HOST'];
			$template = str_replace('##form_action##', $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'], $template);
			
	        if(isset($this -> config['boolean_fields']))
	            $this -> boolean_fields = array_merge($this -> boolean_fields, explode(',', $this->config['boolean_fields']));
	        
	        foreach($data as $key => $value) {
				switch($key) {
					case in_array($key, $this -> boolean_fields):
						if($value == 1)
							$template = str_replace('##data['.$key.']##', ' checked="checked" ', $template);
						else
							$template = str_replace('##data['.$key.']##', '', $template);
						break;
					default:
						$template = str_replace('##data['.strtolower($key).']##', $value, $template);
						break;
				}
			}
			if(!isset($data['id']) || $data['id']==0)
				$template = str_replace('##submit_label##', 'Adauga concurs', $template);
			else
				$template = str_replace('##submit_label##', 'Salveaza modificarile', $template);
			
			$template = preg_replace('/##[a-z0-9\-_\[\]]*##/i', '', $template);
		}
		return $template;
	}
	
	public function save_contest(&$data) {
		global $wpdb;
		
		$updates = array();
		$post_data = $data;
		
        
		foreach($post_data as $key => $value) {
			$key = str_replace('konkurs_', '', $key);            
			$data[$key] = $value;
            if($key!='id' && $key !='type')
                $updates[] = $key .' = "' . $value . '" ';
		}
        
        foreach($this -> boolean_fields as $field) {
            if(!isset($data[$field])) {
                $data[$field] = 0;
                $updates[] = $field .' = "'.$data[$field].'" ';
            }
        }
		//check start and end date
		$start_timestamp = konk_get_timestamp($data['start_date']);
		$end_timestamp = konk_get_timestamp($data['end_date']);
		$now = time();
		
		if($end_timestamp <= $now) {
			$updates[] = ' status = "stopped" ';
            $message = sprintf(__('Concursul <strong>%s</strong> are statusul "oprit" deoarece data de sfarsit a fost setata in trecut.'), $data['title']);
		} elseif($start_timestamp <= $now) {
			$updates[] = ' status = "running" ';
            $message = sprintf(__('Concursul <strong>%s</strong> este activ.'), $data['title']);
		} else {
            $updates[] = ' status = "pending" ';
            $message = sprintf(__('Concursul <strong>%s</strong> va porni la data <b>%s</b>'), $data['title'], $data['start_date']);
        }
                
		if(isset($data['id']) && $data['id']!=0) {        
			$query = 'UPDATE '. $wpdb -> konk_contests .' SET '. implode(',', $updates).' WHERE id = '.$data['id'];
			$success = $wpdb -> query($query);
		} else {
            $updates[] = 'type = "'.$this -> type.'" ';
			$query = 'INSERT INTO '. $wpdb -> konk_contests .' SET '. implode(',', $updates).' ';
			$success = $wpdb -> query($query);
			$data['id'] = mysql_insert_id();						
		}       
        
		if($success!==false) {
            $wave_result = '';
			if($data['wave']==1) {            
				$wave_result = file_get_contents('http://www.konkurs.ro/blog-my-contest.php?id='.$data['id'].'&blog_url='.get_option('siteurl').'&title='.urlencode($data['title']).'&start_date='.urlencode($data['start_date']).'&end_date='.urlencode($data['end_date']));
			}
            return array(
                'success' => true,
                'id'      => $data['id'],
                'message' => sprintf(__('Concursul <strong>%s</strong> a fost salvat'), $data['title']).'<br />'.$message,
                'wave_result' => $wave_result
            );
        } else {
            return array(
                'success' => false,
                'errors'  => array(__('Modificarile nu au putut fi salvate.', 'wp-konkurs'))
            );
        }
			
	}
    
    public static function s_get_all() {
        global $wpdb;
             
        $query = 'SELECT k.*, COUNT(a.id) AS applicants, p.post_type 
                    FROM '.$wpdb -> konk_contests.' k 
                        LEFT JOIN '.$wpdb -> konk_applications .' a ON k.id = a.contest_id 
                        LEFT JOIN '.$wpdb -> prefix.'posts p ON k.contest_page = p.id
                    GROUP BY k.id ORDER BY id DESC ';       
        return $wpdb -> get_results($query, 'ARRAY_A');
    }
    
    public function process_signup() {
        
        global $wpdb;
        $data = $_POST;
        
        $contest_id = $this -> info['id'];
        $email = isset($data['konk_signup_email']) ? $data['konk_signup_email'] : '';
        $url   = isset($data['konk_signup_url']) ? $data['konk_signup_url'] : '';
        $name  = isset($data['konk_signup_name']) ? $data['konk_signup_name'] : '';
        
        $errors = array();
        
        /* VALIDATION */
        $valid = true;
		//check valid email
		if(strlen($email) == 0 || !konk_validate($email,'email')) {
			$errors[] = __('Email-ul tau este invalid');
			$valid = false;
		}
		//check name
		if(strlen($name) == 0) {
			$errors[] = __('Nu ti-ai introdus numele');
			$valid = false;
		}			
			
        //check max apps from same IP limit
        if($this -> info['same_ip_max_apps']>0) {
            $query = 'SELECT count(id) FROM '. $wpdb -> konk_applications .' WHERE ip = "'.$_SERVER['REMOTE_ADDR'].'" AND contest_id = '.$contest_id;
            $app_count = $wpdb -> get_var($query, 0, 0);
            if($app_count >= $this -> info['same_ip_max_apps']) {
                $errors[] = __('S-a atins numarul maxim de inscrieri de la IP-ul tau', 'wp-konkurs');
                $valid = false;
            }
        }
         //check for a previous application
        if($this -> info['max_user_apps'] > 0) {
            $query = 'SELECT COUNT(a.id) FROM '. $wpdb -> konk_applications .' a JOIN '. $wpdb -> konk_applicants .' ap 
                            ON a.applicant_id = ap.id 
                            WHERE ap.email = "'. $wpdb -> escape($email) .'" AND a.contest_id = '.$contest_id;
						
            $app_count = $wpdb -> get_var($query, 0, 0);
            if( $app_count >= $this -> info['max_user_apps']) {
                $errors[] = __('Ai atins numarul maxim de inscrieri in acest concurs', 'wp-konkurs');
                $valid = false;
            }
        }
        //check captcha ( if enabled for this contest )
        if($this -> info['use_captcha']) {			
            if(!isset($data['konk_signup_captcha']) || $data['konk_signup_captcha'] != $_SESSION['wp-konkurs']['captcha_'.$this ->info['id']]) {
                $errors[] = __('Codul din imagine nu este corect', 'wp-konkurs');
                $valid = false;
            }
        }
        
        if(function_exists('konk_module_validate_signup')) {
			$module_errors = konk_module_validate_signup($this, $data);        
			if(count($module_errors)) {
				$errors = array_merge($errors, $module_errors);
				$valid = false;
			}
		}
        
        if($valid) {
        
            $query = 'SELECT id FROM '. $wpdb -> konk_applicants .' WHERE email = "'.$email.'" ';
            $results = $wpdb -> get_results($query, 'ARRAY_A');
        
            if(count($results) == 1) {
                $applicant_id = $results[0]['id'];
            } else {
                $query = 'INSERT INTO '. $wpdb -> konk_applicants .' SET
                                email = "'.$wpdb -> escape($email).'" ';
                
                $wpdb -> query($query);
                $applicant_id = $wpdb -> insert_id;
            }
            
            $answers = array();
            for($i=1;$i<=KONK_CUSTOM_FIELDS_NO;$i++) {
                if(isset($data['konk_signup_answer'.$i]))            
                    $answers[] = ' answer'.$i.' = "'. $wpdb -> escape($data['konk_signup_answer'.$i]).'" ';
            }
            
            $query = 'INSERT INTO '. $wpdb -> konk_applications .' SET
                        contest_id   = '.$contest_id.',
                        applicant_id = '.$applicant_id.',
                        ip           = "'.ip2long($_SERVER['REMOTE_ADDR']).'",
                        referer      = "'.$wpdb -> escape($_SERVER['HTTP_REFERER']).'",
                        user_agent   = "'.$wpdb -> escape($_SERVER['HTTP_USER_AGENT']).'",
                        name = "'.$wpdb -> escape($name).'",
                        site_url = "'.$wpdb -> escape($url).'", '.
                        implode(',', $answers). ( count($answers) ? ',' : '')
                        .'
                        status = "'.($this -> info['approve_apps'] ? 'pending' : 'approved').'",
                        date_created = NOW()';
                        
            $wpdb -> query($query);
			
            if(function_exists('konk_module_process_signup'))
				konk_module_process_signup($this, $data);
            
			$_SESSION['wp-konkurs']['captcha_'.$this ->info['id']] = rand(0,345);
            return array(
                'message' => __('Te-ai inscris cu succes in concurs', 'wp-konkurs'),
                'success' => true
            );
        } else {
            return array(
                'errors' => $errors,
                'success' => false
            );
        }
    }
    
    public function get_signup_form($options = array()) {            
        //add contest data    
		$options = array_merge($options, $this -> info);
        //add constants
        $options['plugin_url'] = KONK_PLUGIN_URL; 
        
        $html = implode('', file(KONK_MODULES_PATH.'/'.$this -> type.'/signup_form.html'));
        
        
        foreach($options as $key => $value) {
            $html = str_replace('##data['.$key.']##', $value, $html);
        }
        
        $html = konk_module_get_signup_form($this, $html, $options);
        
        //check for captcha
        if($this -> info['use_captcha']) {
            $html = konk_strip_template_tag($html, 'captcha', false);
        } else {
            $html = konk_strip_template_tag($html, 'captcha', true);
        }
		
		//check for link to konkurs.ro
		if($this -> info['link_to_konkurs']) {
			$html = konk_strip_template_tag($html, 'token_of_appreciation', false);
		} else {
			$html = konk_strip_template_tag($html, 'token_of_appreciation', true);
		}
        
        //get errors
        if(isset($options['errors']) && count($options['errors'])>0) {
            $html_errors = '<ul>';
            foreach($options['errors'] as $error)
                $html_errors .= '<li>'.$error.'</li>';
            $html_errors.='</ul>';
            $html = str_replace('##errors##', $html_errors, $html);
            $html = konk_strip_template_tag($html, 'errors', false);
        } else {
            $html = konk_strip_template_tag($html, 'errors', true);
        }
        
		/* if ther's any ##data[stuff]##, strip them out */
		$html = konk_strip_template_vars($html);
        return $html;
    }
    
    public function get_applications($status=array(), $app_id=-1) {    
        global $wpdb;
        if(!is_array($status))
            $status = array($status);
            
        $query = 'SELECT a.*, b.email FROM '. $wpdb -> konk_applications .' a JOIN '. $wpdb -> konk_applicants .' b ON a.applicant_id = b.id WHERE a.contest_id = '. $this -> info['id'].' '.
        ( 
			count($status) ? 
			' AND a.status IN ("'.implode('","', $status).'") '.(count($status)==1 && $status[0]=='winner' ? 'ORDER BY priority ASC' : 'ORDER BY date_created') :
			''
		).
		
        ( $app_id > 0 ? ' AND a.id = '.$app_id.' ' : ($app_id == 0 ? ' AND a.status != "winner" ORDER BY RAND() LIMIT 1 ' : ''));        
		
        $results = $wpdb -> get_results($query, 'ARRAY_A');               
		$results = is_array($results) ? $results : array();
        foreach($results as &$result) {
            foreach($result as &$value) {
                $value = htmlentities($value);
            }
        }
        return $results;
    }
	
    
	public function desqualify($app_id) {
		global $wpdb;
		
		$query = 'DELETE FROM '. $wpdb -> konk_applications .' WHERE id = '. $app_id.' ';
		$success = $wpdb -> query($query);
		return $success;
	}
	
	public function set_application_status($app_id, $status, $raw='') {
		global $wpdb;
		
		$query = 'UPDATE '. $wpdb -> konk_applications .' SET status = "'.$status.'" 
		'.($raw !='' ? ', '.$raw : '').'
					WHERE id = '.$app_id.' ';
					
		$success = $wpdb -> query($query);
		return $success;
	}
	
	public function set_winner($app_id, $details='', $priority=0) {
		global $wpdb;
		$this -> set_application_status($app_id, "winner", 'winner_details = "'.$wpdb -> escape($details).'", priority = '.$priority.' ');
	}
	
	public function alert($message) {
		if($this -> info['email_alerts'] == 1) {
			mail(
				get_option('admin_email'), 
				sprintf(__('%s - alerta concurs %s', 'wp-konkurs'), get_option('blogname'), $this -> info['title']), 
				$message,
				"Content-type: text/html;\n"
			);
		}
	}
	
    public static function delete($cid) {
        global $wpdb;
        
        //delete applications
        $query = 'DELETE FROM '. $wpdb -> konk_applications .' WHERE contest_id = '.$cid.' ';
        $wpdb -> query($query);
        
        //delete contest
        $query = 'DELETE FROM '. $wpdb -> konk_contests .' WHERE id = '. $cid.' ';
        $wpdb -> query($query);
    }   
    
    public static function set_contest_page($cid,$pid) {
        
        global $wpdb;
        $query = 'UPDATE '. $wpdb -> konk_contests .' SET contest_page = '.$pid.' WHERE id = '.$cid.' ';
        $wpdb -> query($query);
        
    }
	
    public static function unset_contest_page($pid) {
        global $wpdb;
        $query = 'UPDATE '. $wpdb -> konk_contests .' SET contest_page = 0 WHERE contest_page = '.$pid.' ';
        $wpdb -> query($query);
    }
            
}

?>