<?php
function konk_module_get_signup_form(&$konk, $html, $options = array()) {
    for($i = 1; $i <= KONK_CUSTOM_FIELDS_NO; $i++) {
        if($i <= $konk -> info['question1'])
            $html = konk_strip_template_tag($html, 'email'.$i, false);
        else
            $html = konk_strip_template_tag($html, 'email'.$i, true);
    }
    return $html;
}

function konk_module_validate_signup(&$konk, $data) {
    global $wpdb;
    
    $valid_emails = array();
    //make sure emails are valid
    $errors = array();
    for($i = 1; $i <= $konk -> info['question1']; $i++) {
        if(!isset($data['konk_signup_answer'.$i]) || !konk_validate($data['konk_signup_answer'.$i], 'email')) {            
            $errors[] = sprintf(__('Email invalid: %s', 'wp-konkurs'), $data['konk_signup_answer'.$i]);                              
        } else {
            $valid_emails[] = $data['konk_signup_answer'.$i];
        }
        
    }
    //check for previous invitations to the same people, at this particular contest
    $fields = array();
    $restrictions = array();    
    $found_emails = array();
    
    for($i = 1; $i <= $konk -> info['question1']; $i++) {
        $fields[] = 'answer'.$i;
        $restrictions[] = 'answer'.$i.' IN ("'.implode('","', $valid_emails).'")';
    }
   
    //check for previous invitations to the same people, from the same user, at this particular contest
    $query = 'SELECT '.implode(',',$fields).' FROM '.$wpdb -> konk_applications.' apps JOIN '. $wpdb -> konk_applicants.' ap ON apps.applicant_id = ap.id WHERE
                contest_id = '. $konk -> info['id'].' AND ap.email = "'.$wpdb -> escape($data['konk_signup_email']).'" 
                    AND ( '. implode(' OR ', $restrictions).') ';
                       
    $results = $wpdb -> get_results($query, 'ARRAY_A');
    if(is_array($results) && count($results)>0) {
        foreach($results as $result)
            foreach($result as $field=>$value) {
                if(in_array($value,$valid_emails))
                    $found_emails[] = $value;
            }
    }
        
    if(count($found_emails)>0) {
        $errors[] = sprintf(__('Ai trimis deja invitatii la <strong>%s</strong>', 'wp-konkurs'), implode(', ', $found_emails));
    }       
    return $errors;
}

function konk_module_process_signup(&$konk, $data) {
    $email_template = implode('', file(KONK_MODULES_PATH.'/'.$konk->type.'/invitation_template.html'));
    
    $vars = array(
        'inviter_name'  => $data['konk_signup_name'],
        'inviter_email' => $data['konk_signup_email'],
        'siteurl'     => get_option('siteurl'),
        'blogname'    => get_option('blogname'),
        'blogdescription' => get_option('blogdescription')
    );
    $email_subject = $konk -> config['invitation_subject'];
    $email_from    = $konk -> config['invitation_from'];
    $email_headers = "Content-type: text/html\nFrom: ".$email_from."\n";
    foreach($vars as $key => $value) {
        $email_template = str_replace('##data['.$key.']##', $value, $email_template);
        $email_subject = str_replace('##data['.$key.']##', $value, $email_subject);
    }     
    for($i=1; $i <= $konk -> info['question1']; $i++) {
        $invitee = $data['konk_signup_answer'.$i];
        mail($invitee, $email_subject, $email_template, $email_headers);
    }
    return true;
}

function konk_module_get_application(&$konk, $app) {
    
    $invitations = array();
        for($i=1; $i<=$konk->info['question1']; $i++) {            
            $invitations[] = $app['answer'.$i];
        }
        
    return __('<strong>Invitatii trimise:</strong>', 'wp-konkurs').' '.konk_clickable_links(implode(', ', $invitations));
}

?> 