<?php
/*        
Plugin Name: Konkurs - Lanseaza concursuri la tine pe blog
Plugin URI: http://www.konkurs.ro/
Description: Lanseaza si administreaza diverse tipuri de concursuri chiar la tine pe blog. Promoveaza-ti concursurile automat si gratuit pe Konkurs.ro. Pasul 1: activeaza pluginul. Pasul 2: <a href="edit.php?page=wp-konkurs.php&act=add">adauga primul tau concurs</a>.
Version: 1.0
Author: Konkurs.ro
Author URI: http://www.konkurs.ro

Copyright 2008  Konkurs.ro  (email : matei@konkurs.ro)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/




if(function_exists('register_activation_hook'))
    register_activation_hook( __FILE__, 'konk_activate');

if (!function_exists('is_admin_page')) {
	function is_admin_page() {
		if (function_exists('is_admin')) {
			return is_admin();
		}
		if (function_exists('check_admin_referer')) {
			return true;
		}
		else {
			return false;   
		}
	}
}



/*if (!isset($wpdb)) {
	require_once('../../wp-blog-header.php');
	konk_init();
} */


DEFINE('KONK_PLUGIN_URL', get_option('siteurl').'/wp-content/plugins/wp-konkurs');
DEFINE('KONK_PLUGIN_PATH', dirname(__FILE__));
DEFINE('KONK_ADMIN_URL', get_option('siteurl').'/wp-admin/edit.php?page=wp-konkurs.php');
DEFINE('KONK_MODULES_PATH', KONK_PLUGIN_PATH.'/modules');
DEFINE('KONK_CUSTOM_FIELDS_NO', 5);
DEFINE('KONK_FILE_ERROR', '<div class="konk_reports">Fisierul <b>%s</b> trebuie sa aiba permisiunile setate pe <b>%s</b><br /><br /><a target="_blank" href="http://www.konkurs.ro/concursuri-pentru-bloggeri/FAQ">cum fac asta?</a></div>');
DEFINE('KONK_DIR_ERROR',  '<div class="konk_reports">Folderul <b>%s</b> trebuie sa aiba permisiunile setate pe <b>%s</b><br /><br /><a target="_blank" href="http://www.konkurs.ro/concursuri-pentru-bloggeri/FAQ">cum fac asta?</a></div>');

require_once(KONK_PLUGIN_PATH.'/konkurs.class.php');
require_once(KONK_PLUGIN_PATH.'/wp-konkurs-message-codes.php');
$konk_instances = array();

/*core functions*/
function konk_strip_template_tag($html, $tag, $strip_content=false) {
    if($strip_content) {
        $slot_start = strpos($html, '{'.$tag.'}');
        $slot_end   = strpos($html, '{/'.$tag.'}') + (3 + strlen($tag));
        $html = substr($html, 0, $slot_start).substr($html, $slot_end);
    } else {
        $html = str_replace(array('{'.$tag.'}', '{/'.$tag.'}'), '', $html);
    }
    
    return $html;
}

function konk_strip_template_vars($html) {
	return preg_replace('/##data\[[a-z0-9\-_]*\]##/i', '', $html);
}

function konk_init() {	
    global $wpdb;
	
    ob_start();
    
    if(strlen(session_id())==0)
        session_start();
    
	$wpdb -> konk_contests     = $wpdb->prefix . 'konk_contests';
	$wpdb -> konk_applications = $wpdb->prefix . 'konk_applications';
    $wpdb -> konk_applicants   = $wpdb->prefix . 'konk_applicants';
    $wpdb -> konk_winners      = $wpdb->prefix . 'konk_winners';
        
    load_plugin_textdomain('wp-konkurs', 'wp-content/plugins/wp-konkurs');
}

function konk_activate() {
    global $wpdb;
    
    $query = 'SHOW TABLES';
    $tables = $wpdb -> get_results($query, 'ARRAY_N');		
    
    $konk_tables = array($wpdb -> prefix.'konk_contests', $wpdb -> prefix.'konk_applications', $wpdb -> prefix.'konk_applicants');

    $table_count = 0;
    foreach($tables as $table) {
        if(in_array($table[0], $konk_tables)) {
            $table_count++;
        }
    }		

    if($table_count == 0) {							
        konk_install();
    }         
}

function konk_install() {
    global $wpdb;
    

    $query = 'CREATE TABLE `'.$wpdb->prefix .'konk_applicants` (
                `id` int(11) NOT NULL auto_increment,
                `email` varchar(100) NOT NULL,
                PRIMARY KEY  (`id`)
              ) ENGINE=MyISAM;';
    $wpdb -> query($query);
    
    $query = 'CREATE TABLE `'.$wpdb->prefix.'konk_applications` (
                  `id` int(11) NOT NULL auto_increment,
                  `name` varchar(60) NOT NULL,
                  `site_url` varchar(150) NOT NULL,
                  `contest_id` int(11) NOT NULL,
                  `applicant_id` int(11) NOT NULL,
                  `answer1` text,
                  `answer2` text,
                  `answer3` text,
                  `answer4` text NOT NULL,
                  `answer5` text NOT NULL,
                  `votes` int(11) NOT NULL,
                  `grade` int(11) NOT NULL,
                  `rating` decimal(3,2) NOT NULL,
                  `date_created` datetime NOT NULL,
                  `ip` bigint(20) NOT NULL,
                  `referer` varchar(250) NOT NULL,
                  `user_agent` varchar(250) NOT NULL,
                  `status` enum("pending","approved","rejected","winner") NOT NULL,
                  `winner_details` text,
                  `priority` int(11) NOT NULL,
                  `email_validation` int(11) NOT NULL default "0",
                  PRIMARY KEY  (`id`),
                  KEY `applicant_id` (`applicant_id`),
                  KEY `contest_id` (`contest_id`)
               ) ENGINE=MyISAM';
    
    $wpdb -> query($query);
    
    $query = 'CREATE TABLE `'.$wpdb->prefix.'konk_contests` (
                  `id` int(11) NOT NULL auto_increment,
                  `type` varchar(60) NOT NULL,
                  `same_ip_max_apps` int(11) NOT NULL default "10",
                  `title` varchar(255) NOT NULL,
                  `question1` varchar(255) default NULL,
                  `question2` varchar(255) default NULL,
                  `question3` varchar(255) default NULL,
                  `question4` varchar(255) default NULL,
                  `question5` varchar(255) default NULL,
                  `start_date` datetime NOT NULL,
                  `end_date` datetime NOT NULL,
                  `status` enum("running","pending","stopped") NOT NULL,
                  `active` int(11) NOT NULL default "1",
                  `max_user_apps` int(11) NOT NULL default "0",
                  `details` text NOT NULL,
                  `date_created` datetime NOT NULL,
                  `approve_apps` int(11) NOT NULL default "0",
                  `apps_per_page` int(11) NOT NULL default "20",
                  `email_alerts` int(11) NOT NULL,
                  `email_validation` int(11) NOT NULL default "1",
                  `use_captcha` int(11) NOT NULL,
                  `link_to_konkurs` int(11) NOT NULL default "1",
                  `wave` int(11) NOT NULL default "1",
                  `contest_page` int(11) default NULL,
                  PRIMARY KEY  (`id`)
            ) ENGINE=MyISAM';
     
    $wpdb -> query($query);
}

function konk_add_report($report) {    
    if(is_array($report))
        $report = implode('', $report);
    if(!isset($_SESSION['wp-konkurs-reports']))
        $_SESSION['wp-konkurs-reports'] = array();
    
    $_SESSION['wp-konkurs-reports'][] = $report;
}

function konk_get_reports() {
    $reports = isset($_SESSION['wp-konkurs-reports']) ? $_SESSION['wp-konkurs-reports'] : array();    
    $_SESSION['wp-konkurs-reports'] = array();
    
    $html = '';
    if(count($reports)) {
        $html = '<ul class="konk_reports">';
        
        foreach($reports as $report) {
            $html.= '<li>'.$report.'</li>';
        }
        $html .= '</ul>';    
    }
    return $html;
}

function konk_admin_get_page() {
    $act = isset($_GET['act']) ? $_GET['act'] : 'list';
	$use_header = true;
    switch($act) {
        case 'list':
            $center_piece = konk_admin_list_contests();			
            break;
        case 'add':
            if(isset($_GET['type']))
                $center_piece = konk_admin_add_contest($_GET['type']);            
            else
                $center_piece = konk_admin_list_modules();
            break;
		case 'step2':
			$center_piece = konk_admin_show_help('step2', $_GET);
			break;
        case 'edit':
            $center_piece = konk_admin_edit_contest();
            break;
		case 'stop':
			konk_stop_contest();
        case 'delete':
            konk_admin_del_contest();
            break;
        case 'applications':
			$use_header = false;
            $center_piece = konk_admin_list_apps();
            break;
    }
	
	$updates = file_get_contents('http://www.konkurs.ro/connect/updates.txt');
	
    $reports = konk_get_reports();
    $admin_page = '
    <div class="wrap">'.($use_header ? '
        <h2>Konkursuri (<a href="'.KONK_ADMIN_URL.'&act=add">concurs nou</a>)</h2>
        <ul class="subsubsub">
            <li><a href="'.KONK_ADMIN_URL.'&act=list">'.__('Lista concursurilor').'</a> | </li>
            <li><a href="'.KONK_ADMIN_URL.'&act=add">'.__('Adauga concurs').'</a> | </li>
            <li><a href="http://www.konkurs.ro/concursuri-pentru-bloggeri/documentatie" target="_blank">'.__('Documentatie').'</a> | </li>            
            <li><a href="http://www.konkurs.ro/concursuri-pentru-bloggeri/bugs" target="_blank">'.__('Raporteaza un BUG').'</a> </li>            
        </ul> ' : '').$updates.(strlen($reports) ? '
        <div class="konk-admin-reports">
            '.konk_get_reports().'
        </div>
        ' : '').$center_piece.'
    </div>';
    
    echo $admin_page;
}	

function konk_admin_list_modules() {
    $modules = array();
	$content = '';
	$readable = true;
	if(is_readable(KONK_MODULES_PATH)) {
	    $h = opendir(KONK_MODULES_PATH);
	    $content = '<div class="konk_help"><b>Alege tipul concursului</b><p>Tipul concursului influenteaza atat campurile formularului de inscriere cat si procesul si conditiile de participare. Pentru informatii despre tipurile de concursuri disponibile, citeste cu atentie descrierea fiecarui tip de concurs.</p></div>';        
	    
	    if($h) {
			$count = 0;
			$content .= '<ul style="margin: 10px;">';
	        while(false !== ($module = readdir($h))) {            	
				$count++;
	            $module_path = KONK_MODULES_PATH.'/'.$module;
	            if(is_dir($module_path) && $module!='.' && $module!='..') {
	                $module_info = konk_get_module($module_path);
	                if($module_info !== false)
	                    $content .= '<li><a href="'. KONK_ADMIN_URL .'&act=add&type='.$module.'">'.$module_info['name'].'</a><br /><p>'.$module_info['description'].'</p></li>';
	            }   
	        }
			$content .= '</ul>';
			if($count == 0)
				$readable = false;
		} else $readable = false; 
    } else {
		$readable = false;		
	}
	
	if(!$readable) {
		$content = sprintf(KONK_DIR_ERROR, KONK_MODULES_PATH, 755);
	}	
    return $content;
}

function konk_get_module($module) {
    $return = array();
    $settings_file = $module.'/config.inc.txt';
	$readable = true;
    if(file_exists($settings_file) && is_readable($settings_file)) {
        $lines = file($settings_file);
		if(count($lines)>0) {
			foreach($lines as $line) {
				$line_parts = explode('=', $line);
				$key = array_shift($line_parts);
				$value = implode('=', $line_parts);
				$return[$key] = $value;
			}
			return $return;    
		} else {
			$readable = false;
		}
    } else {		
		$readable = false;
	}
	
	if(!$readable) {
		printf(KONK_FILE_ERROR, $settings_file, 644);
		return false;
	}
    return false;
}   

function konk_admin_show_help($part='', $params=array()) {
	if($part!='' && file_exists(KONK_PLUGIN_PATH.'/docs/'.$part.'.html'))
		$info = implode('', file(KONK_PLUGIN_PATH.'/docs/'.$part.'.html'));
	else
		$info = implode('', file(KONK_PLUGIN_PATH.'/docs/index.html'));

	$params['siteurl'] = get_option('siteurl');
	$params['pluginurl'] = KONK_ADMIN_URL;
	
	foreach($params as $key => $value) {
		$info = str_replace('##'.$key.'##', $value, $info);
	}
	
	return $info;	
}

function konk_admin_list_contests() {
    
	
	$list = konkurs::s_get_all();
	if(is_array($list) && count($list) > 0) {
	$content = '
        <table class="widefat">
            <thead>
                <tr>
                    <th scope="col" width="10">ID</th>
                    <th scope="col">'.__('Titlu concurs', 'wp-konkurs').'</th>
                    <th scope="col">'.__('Perioada', 'wp-konkurs').'</th>
                    <th scope="col" width="10">'.__('Inscrieri', 'wp-konkurs').'</th>
                    <th scope="col">::</th>
                </tr>
            </thead>
            <tbody>';
        foreach($list as $item) {
            $content .= '
                <tr>
                    <td class="">'.$item['id'].'</td>
                    <td>
                        <a href="'.KONK_ADMIN_URL.'&act=edit&id='.$item['id'].'">'.$item['title'].'</a><br />
                        '.__('Codul pentru formularul de inscriere', 'wp-konkurs').': [konk_signup id='.$item['id'].']
                    </td>
                    <td>'.mysql2date('d F Y', $item['start_date']).' - '.mysql2date('d F Y', $item['end_date']).'<br />'.
                    ($item['status']=='running' ? 'concurs activ' : ($item['status']=='pending' ? 'concursul nu a pornit inca' : 'concursul s-a terminat'))
                    .'</td>
                    <td><a href="'.KONK_ADMIN_URL.'&act=applications&id='.$item['id'].'">'.(int)$item['applicants'].'</a></td>
                    <td>
                        '.($item['post_type'] != '' ? '<a href="'.$item['post_type'].'.php?action=edit&post='.$item['contest_page'].'">'.__('modfica pagina concursului', 'wp-konkurs').'</a> | ' : '<a href="'.KONK_ADMIN_URL.'&act=step2&cid='.$item['id'].'">'.__('creeaza pagina concursului', 'wp-konkurs').'</a> | ').'
                            
                        <a onclick="return confirm(\''.__('Stergerea concursului va sterge toate inscrierile asociate! Kontinuati?', 'wp-konkurs').'\');" href="'.KONK_ADMIN_URL.'&act=delete&id='.$item['id'].'">'.__('sterge concursul', 'wp-konkurs').'</a> 
                    </td>
                </tr>';
                    
        }
		$content .= '</tbody></table>';		
    } else {
		$content = '<div class="konk_help"><p>Ai instalat cu succes WP-Konkurs - plugin de concursuri pe blog.<br /><br />
		Esti gata pentru primul tau concurs?</p><p><a href="'.KONK_ADMIN_URL.'&act=add">Gata!</a></p></div>';        
	}
    
    return $content;
}

function konk_admin_add_contest($type) {
    global $konk_message_codes;
    
    $konk = new konkurs(-1, $type);
    if(count($_POST)) {
        $result = $konk -> save_contest($_POST);
        
        if($result['success']) {
            konk_add_report($result['message']);            
            header('Location:'.KONK_ADMIN_URL.'&act=step2&cid='.$result['id']);
            exit;
        } else {    
            foreach($result['errors'] as $error)
                konk_add_report($error);
        }
    } else {
        $_POST = array(
            'max_user_apps' => 0,      
            'email_alerts' => 1,
            'wave' => 1,
            'link_to_konkurs' => 1,
            'start_date' => date('Y-m-d H:i:s'),
            'end_date' => date('Y-m-d H:i:s', strtotime('next month'))
        );
    }
    return $konk -> get_form('contest_form', $_POST);
}

function konk_admin_edit_contest() {
    $id = isset($_GET['id']) ? (int)$_GET['id'] : 0;
    if($id) {
        $konk = new konkurs($id);
        $data = $konk -> info;
        if(count($_POST)) {
            $data = $_POST;
            $result = $konk -> save_contest($_POST);
            if($result['success']) {
                konk_add_report($result['message']);            
                header('Location:'.KONK_ADMIN_URL);
                exit;
            } else {    
                foreach($result['errors'] as $error) {
                    konk_add_report($error);
                }
            }
        }        
        
        return $konk -> get_form('contest_form', $data);
    }    
}

function konk_admin_del_contest() {
    $id = isset($_GET['id']) ? (int)$_GET['id'] : 0;
    konkurs::delete($id);
    konk_add_report(__('Concursul a fost sters.', 'wp-konkurs'));
    header('Location: '. KONK_ADMIN_URL);
    exit;
}

function konk_admin_list_apps() {
    
    $id = isset($_GET['id']) ? (int)$_GET['id'] : 0;    
	$konk = new konkurs($id);    
	$content = '<h2>Concurs: '.$konk -> info['title'].' (<a href="'.KONK_ADMIN_URL.'">inapoi</a>)</h2>';
	$content.= '<ul class="subsubsub"><li><a href="'.KONK_ADMIN_URL.'&act=applications&id='.$id.'&mod=setwinner&app_id=0">alege castigator aleator</a> | </li><li><a href="'.KONK_ADMIN_URL.'&act=edit&id='.$id.'">modifica datele concursului</a></li></ul>';
    
	if(isset($_GET['app_id'])) {
		switch($_GET['mod']) {
			case 'desq':
				$konk -> desqualify($_GET['app_id']);
				break;
			case 'approve':
				$konk -> set_application_status($_GET['app_id'], 'approved');
				break;
			case 'unset_winner':
				$konk -> set_application_status($_GET['app_id'], 'approved');
				break;
            case 'setwinner':
                $app_id = isset($_POST['app_id']) ? $_POST['app_id'] : $_GET['app_id'];
                $winner = array_shift($konk -> get_applications(array('approved','winner'),$app_id));
                $answers = konk_module_get_application($konk, $winner);
                if(isset($_POST['winner_details'])) {
                    $konk -> set_winner($app_id, $_POST['winner_details'], $_POST['priority']);                    
                    konk_add_report(sprintf(__('<strong>%s</strong> a fost ales castigator!'), $winner['name']));
                    header('Location:'.KONK_ADMIN_URL.'&act=applications&id='.$id);
                    exit;
                } else {
                    if(is_array($winner)) {
                        $content .= '   
    						<div class="postbox">
    						<h2>Detalii castigator '.($app_id == 0 ? '(<a href="'.KONK_ADMIN_URL.'&act=applications&id='.$id.'&mod=setwinner&app_id=0">alege alt castigator</a>)' : '').'</h2>
                            <form action="" method="POST">
                            <input type="hidden" name="app_id" value="'.$winner['id'].'" />
                            <table class="form-table" width="400">
    							<tbody>
                                <tr class="form-field">
                                    <th scope="row">'.__('Nume').': </th><td>'.$winner['name'].'</td>
    							</tr>
    							<tr class="form-field">
    								<th scope="row">'.__('Data').': </th><td>'.mysql2date('d F Y', $winner['date_created']).' '.substr($winner['date_created'], 11, 5).'</td>
    							</tr>
    							<tr class="form-field">
    								<th scope="row">'.__('Inscris cu').': </th><td>'.$answers.'</td>
    							</tr>
								<tr class="form-field">
									<th scope="row">'.__('Prioritate fata de ceilalti castigatori').'</th>
									<td>
										<input type="text" size="3" name="priority" value="'.$winner['priority'].'" />
										<p>'.sprintf(__('Acest numar determina ordinea afisarii castigatorilor daca decizi sa afisezi castagatorii concursului folosind codul <strong>[konk_winner_list id=%s]</strong>'), $id).'</p>
									</td>
								</tr>
    							<tr class="form-field">
                                    <th scope="row">Detalii premiu:</th><td><textarea name="winner_details">'.$winner['winner_details'].'</textarea></td>
                                </tr>
                                <tr class="form-field">
    								<td>&nbsp;</td>
                                    <td>
                                        <input type="submit" class="button" value="Okay" />&nbsp;<a class="rbutton" href="'.KONK_ADMIN_URL.'&act=applications&id='.$id.'">Anuleaza</a>
                                    </td>
                                </tr>
    							</tbdoy>
                            </table>
                            </form>
    						</div>';
                    } else {
                        konk_add_report(__('Toate inscrierile sunt castigatoare. Pentru a modifica premiile, click pe "modifica premii" in dreptul fiecarui castigator'));
                    }
                }
                break;
		}
	}
	$winners = $konk -> get_applications('winner');	
	
    $apps = $konk -> get_applications();    
    $content .= '<table class="widefat">
            <thead>
                <tr>
                    <th scope="col" width="5">'.__('Nr. crt', 'wp-konkurs').'.</th>
                    <th scope="col" width="200">'.__('Concurent', 'wp-konkurs').'</th>
                    <th scope="col" width="50">'.__('Data&ora', 'wp-konkurs').'</th>
                    <th scope="col" width="300"">'.__('Date inscriere', 'wp-konkurs').'</th>
                    <th scope="col" width="50">'.__('Status', 'wp-konkurs').'</th>
                    <th scope="col">::</th>
                </tr>
            </thead>
            <tbody>';
			
	$winner_count = 0;
	if(is_array($winners) && count($winners)) {
		$winner_count = count($winners);
		$content .= '<tr><td colspan="6"><b>Castigatori:</b></td></tr>';
		$apps = array_merge($winners, $apps);
	}
	
	$count = 0;
    if(is_array($apps)) {
		
        foreach($apps as $key => $app) {
			$showing_winners = ($count == $winner_count) ? false : true;
            $applicant = '<b>'.__('Nume').':</b> '.( strlen($app['site_url']) ? '<a href="'.$app['site_url'].'">'.$app['name'].'</a>' : $app['name'] ).       
                         '<br /><b>'.__('Email', 'wp-konkurs').':</b> <a href="mailto:'.$app['email'].'">'.$app['email'].'</a>'.
                         '<br /><b>'.__('URL', 'wp-konkurs').':</b> <a target="_blank" href="'.$app['site_url'].'">'.$app['site_url'].'</a>';
            
            $answers = konk_module_get_application($konk, $app);
                        
            $content .= '
                <tr>
                    <td>'.($showing_winners ? ($key+1) : ($key+1-$winner_count)).'.</td>
                    <td>'.$applicant.'</td>
                    <td>'.mysql2date('d F Y', $app['date_created']).' '.substr($app['date_created'], 11, 5).'</td>
                    <td>'.$answers.'</td>
                    <td>'.__($app['status'], 'wp-konkurs').'</td>
                    <td>
                       '.( $app['status'] == 'pending' ? '<a href="'.KONK_ADMIN_URL.'&act=applications&id='.$id.'&app_id='.$app['id'].'&mod=approve">'.__('valideaza', 'wp-konkurs').'</a> | ' : '').
					   ( $app['status'] == 'winner' ? '
                               <a href="'.KONK_ADMIN_URL.'&act=applications&id='.$id.'&app_id='.$app['id'].'&mod=unset_winner">'.__('anuleaza premiu', 'wp-konkurs').'</a> | 
                               <a href="'.KONK_ADMIN_URL.'&act=applications&id='.$id.'&app_id='.$app['id'].'&mod=setwinner">'.__('modifica premiu', 'wp-konkurs').'</a> | 
                               ' 
                               : '').
					   ( $app['status'] == 'approved' ? '<a href="'.KONK_ADMIN_URL.'&act=applications&id='.$id.'&app_id='.$app['id'].'&mod=setwinner">'.__('alege castigator', 'wp-konkurs').'</a> | ' : '').
                       '<a onclick="return confirm(\''.__('Descalificarea presupune stergerea definitiva din baza de date. Kontinuati?', 'wp-konkurs').'\');" href="'.KONK_ADMIN_URL.'&act=applications&id='.$id.'&app_id='.$app['id'].'&mod=desq">'.__('descalifica', 'wp-konkurs').'</a>
                    </td>
                </tr>';            
			$count++;
			if($count == $winner_count)
				$content .= '<tr><td colspan="6"><b>Toate inscrierile (##total_signups##)</b></td></tr>';
        }    
    }
    $content .= '</tbody></table>';
	$content = str_replace('##total_signups##', ($count - $winner_count), $content);
    return $content;
}

function konk_admin_add_menus() {
	if (function_exists('add_submenu_page')) {
		add_submenu_page(
			'edit.php'
			, __('Konkursuri', 'wp-konkurs')
			, __('Konkursuri', 'wp-konkurs')
			, 0
			, basename(__FILE__)
			, 'konk_admin_get_page'
		);
	}
}

function konk_admin_set_contest_page($post_id) {
    
    global $wpdb;
    
    $query = 'SELECT post_content,post_type FROM '.$wpdb->prefix.'posts WHERE id = '.$post_id.' AND 
                post_content LIKE "%[konk_signup%" ';
    $results = $wpdb -> get_results($query, 'ARRAY_A');
    if(count($results)>0) {
        $post = $results[0];
        $matches = array();
        
        preg_match('/\[konk_signup\s*id=([0-9]*)\s*\]/', $post['post_content'], $matches);
        $contest_id = $matches[1];
        
        konkurs :: set_contest_page($contest_id, $post_id, $post['post_type']);
    } else {
        konkurs :: unset_contest_page($post_id);
    }
}

function konk_admin_unset_contest_page($post_id) {
    konkurs :: unset_contest_page($post_id);
}

function konk_admin_header() {
    // echo '<script type="text/javascript" src="'. KONK_PLUGIN_URL .'/wp-konkurs-admin.js"></script>'; 
    echo '<link type="text/css" rel="stylesheet" href="'. KONK_PLUGIN_URL .'/wp-konkurs-admin.css" />';
    echo '<script type="text/javascript" src="'. KONK_PLUGIN_URL .'/wp-konkurs-admin.js"></script>';
}   

/* user-side */
function konk_user_signup($params, $content=null) {
    global $konk_instances;
    $id = isset($params['id']) ? (int)$params['id'] : 0;
	$content = '';
    if($id && !in_array($id, $konk_instances)) {
		$data = array();        
        $konk = new konkurs($id, "running");
        if($konk -> info['status'] != 'running')
            return '';
		if($konk !== false) {
	        if(isset($_POST['konk_signup_id']) && $id == $_POST['konk_signup_id']) {
				$data = $_POST;
	            $result = $konk -> process_signup();
	            if($result['success']) {
	                $konk -> alert(__('Inscriere noua'));
	                konk_add_report($result['message']);
					$data = array();				
	            } else {                
                    $data['errors'] = $result['errors'];
	            }
	        }
			if(isset($result) && $result['success'])
				$content .= konk_get_reports();
			else {
				$form = $konk -> get_signup_form($data);		
				$content .= $form;
			}
			$konk_instances[] = $id;    
		}
    }
	return $content;
}
function konk_user_app_list($params, $content = null) {
    $id = isset($params['id']) ? (int)$params['id'] : 0;
    
    if($id) {
        $konk = new konkurs($id);
        $apps = $konk -> get_applications(array('approved','winner'));
        $hidden_fields = isset($params['hide']) ? explode(',', $params['hide']) : array();
        
		$content = '<ol class="konk-winner-list">';
		
		foreach($apps as $key => $app) {
			$applicant = strlen($app['site_url']) ? '<a href="'.$app['site_url'].'">'.$app['name'].'</a>' : $app['name'];
            $answers = konk_module_get_application($konk, $app);
			$content .= '<li><strong>'.$applicant.'</strong>'.
							(!in_array('app',$hidden_fields) ? '<br />'.$answers.'' : '').'
						</li>';
		}
		$content .='</ol>';
        
        return $content;
    }   
}

function konk_user_start_date($params, $content=null) {
    if(!isset($params['format']))
        $dateformat = "d/m/Y H:i";
    else    
        $dateformat = $params['format'];
    
    $konk = new konkurs($id);
    
    $date = date($dateformat, strtotime($konk -> info['start_date']));
    return $date;
}

function konk_user_end_date($params, $content=null) {
    if(!isset($params['format']))
        $dateformat = "d/m/Y H:i";
    else    
        $dateformat = $params['format'];
    
    $konk = new konkurs($id);
    
    $date = date($dateformat, strtotime($konk -> info['end_date']));
    return $date;
}

function konk_user_winner_list($params, $content = null) {
    $id = isset($params['id']) ? (int)$params['id'] : 0;
    if($id) {
        $konk = new konkurs($id);
        $apps = $konk -> get_applications(array('winner'));
        $hidden_fields = isset($params['hide']) ? explode(',', $params['hide']) : array();
        
		$content = '<ol class="konk-winner-list">';
		
		foreach($apps as $key => $app) {
			$applicant = strlen($app['site_url']) ? '<a href="'.$app['site_url'].'">'.$app['name'].'</a>' : $app['name'];
            $answers = konk_module_get_application($konk, $app);
			$content .= '<li><strong>'.$applicant.'</strong>'.
							(!in_array('prize',$hidden_fields) ? '<br />'.$app['winner_details'].'' : '').
							(!in_array('app',$hidden_fields) ? '<br />'.$answers.'' : '').'
						</li>';
		}
		$content .='</ol>';
        
        return $content;
    }   
}

function konk_user_header() {
	echo '<link rel="stylesheet" type="text/css" href="'.KONK_PLUGIN_URL.'/wp-konkurs.css" />';
}

function konk_clickable_links($text) {
    $text = eregi_replace('(((f|ht){1}tp://)[-a-zA-Z0-9@:%_+.~#?&//=]+)',
    '<a href="\1">\1</a>', $text);
    $text = eregi_replace('([[:space:]()[{}])(www.[-a-zA-Z0-9@:%_+.~#?&//=]+)',
    '\1<a href="http://\2">\2</a>', $text);
    $text = eregi_replace('([_.0-9a-z-]+@([0-9a-z][0-9a-z-]+.)+[a-z]{2,3})',
    '<a href="mailto:\1">\1</a>', $text);
  
    return $text;
}

function konk_translate_errors($error_codes = array()) {
	global $konk_message_codes;
	$return = array();
    
	if(is_array($error_codes) && count($error_codes)) {
    	foreach($error_codes as $code) {
            $params = explode('|', $code);
            $code = array_shift($params);
            
    		if(isset($konk_message_codes[$code])) {
    			$message = $konk_message_codes[$code];
    			foreach($params as $key => $value) {
    				$message = str_replace('[%'.($key+1).']', $value, $message);				
    			}
    			$return[] = $message;
    		}
    	}
    }
	return $return;
}

function konk_get_timestamp($mysql_date) {
	list($y,$m,$d) = explode('-', substr($mysql_date,0,10));
	list($h,$i,$s) = explode(':', substr($mysql_date, 11,10));
	return mktime($h, $i, $s, $m, $d, $y);
}

function konk_validate($data, $type='email') {
    switch($type) {
        case 'email':
            return eregi("^([a-z0-9_]|\\-|\\.)+@(([a-z0-9_]|\\-)+\\.)+[a-z]{2,4}$", $data);
            break;
        case 'url':
            return eregi("^((f|ht){1}tp://)[-a-zA-Z0-9@:%_+.~#?&//=]+$", $data);
            break;
    }    
}

//init konkurs
add_action('init', 'konk_init');
//add administration page to menu
add_action('admin_menu', 'konk_admin_add_menus');
add_action('admin_head', 'konk_admin_header');

add_action('wp_head', 'konk_user_header');
//add hooks
add_action('save_post', 'konk_admin_set_contest_page');
add_action('delete_post', 'konk_admin_unset_contest_page');

//add shortcodes
add_shortcode('konk_signup',      'konk_user_signup');
add_shortcode('konk_app_list',    'konk_user_app_list');
add_shortcode('konk_winner_list', 'konk_user_winner_list');
add_shortcode('konk_app_count',   'konk_user_app_count');
add_shortcode('konk_start_date',  'konk_user_start_date');
add_shortcode('konk_end_date',    'konk_user_end_date');

?>
